//========================================================================================
//
//	File:				PROrdCol.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PRORDCOL_H
#define PRORDCOL_H

#ifndef SLCOLLEC_H
#include "SLCollec.h"
#endif

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

//========================================================================================
// Ordered Collection extern C
//========================================================================================

// Export or Import functions for CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

FW_EXTERN_C_BEGIN

unsigned long SL_API		FW_PrivOrderedCollection_Count(FW_HLinkedList collection);
	
FW_PlatformError SL_API		FW_PrivOrderedCollection_AddFirst(FW_HLinkedList collection, 
																const void* element);
FW_PlatformError SL_API		FW_PrivOrderedCollection_AddLast(FW_HLinkedList collection, 
																const void* element);
FW_PlatformError SL_API		FW_PrivOrderedCollection_AddBefore(FW_HLinkedList collection, 
																FW_OrderedCollection_MatchProc matchProc, 
																const void* existing, 
																const void* tobeadded);
FW_PlatformError SL_API		FW_PrivOrderedCollection_AddAfter(FW_HLinkedList collection,
																FW_OrderedCollection_MatchProc matchProc, 
																const void* existing, 
																const void* tobeadded);

void* SL_API				FW_PrivOrderedCollection_After(FW_HLinkedList collection,
																FW_OrderedCollection_MatchProc matchProc,
																const void* existing); 
void* SL_API				FW_PrivOrderedCollection_Before(FW_HLinkedList collection, 
																FW_OrderedCollection_MatchProc matchProc, 
																const void* existing);
																
void* SL_API				FW_PrivOrderedCollection_First(FW_HLinkedList collection);
void* SL_API				FW_PrivOrderedCollection_Last(FW_HLinkedList collection);

void* SL_API				FW_PrivOrderedCollection_RemoveFirst(FW_HLinkedList collection);
void* SL_API				FW_PrivOrderedCollection_RemoveLast(FW_HLinkedList collection);
void SL_API					FW_PrivOrderedCollection_RemoveAll(FW_HLinkedList collection);
			
void SL_API					FW_PrivOrderedCollection_Remove(FW_HLinkedList collection, 
																FW_OrderedCollection_MatchProc matchProc, 
																const void* existing);
FW_Boolean SL_API			FW_PrivOrderedCollection_Contains(FW_HLinkedList collection, 
																FW_OrderedCollection_MatchProc matchProc, 
																const void* existing);

//========================================================================================
// Ordered Collection Iterator extern C
//========================================================================================

void* SL_API				FW_PrivOrderedCollectionIterator_First(FW_HLinkedListIterator iterator);
void* SL_API				FW_PrivOrderedCollectionIterator_Next(FW_HLinkedListIterator iterator);
void* SL_API				FW_PrivOrderedCollectionIterator_Last(FW_HLinkedListIterator iterator);
void* SL_API				FW_PrivOrderedCollectionIterator_Previous(FW_HLinkedListIterator iterator);
FW_Boolean SL_API			FW_PrivOrderedCollectionIterator_IsNotComplete(FW_HLinkedListIterator iterator);

FW_EXTERN_C_END

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

#endif
