//========================================================================================
//
//	File:				SLCollec.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef SLCOLLEC_H
#define SLCOLLEC_H

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

//========================================================================================
// Forward Class Declarations
//========================================================================================

class FW_CPrivLinkedList;
class FW_CPrivLinkedListIterator;

//========================================================================================
// Matching Proc
//========================================================================================

typedef FW_Boolean (*FW_OrderedCollection_MatchProc)(const void* v1,const void* v2);

//========================================================================================
// Type definitions
//========================================================================================

typedef FW_CPrivLinkedList* 			FW_HLinkedList;
typedef FW_CPrivLinkedListIterator* 	FW_HLinkedListIterator;

//========================================================================================
// Extern C Methods
//========================================================================================

// Export or Import functions for CFM-68K [sfu]

FW_EXTERN_C_BEGIN

#if defined(FW_ODFLIB_IMPORT)
#pragma import on
#elif defined(FW_ODFLIB)
#pragma export on
#endif

extern FW_HLinkedList 				FW_PrivNewLinkedList(FW_PlatformError* error);
extern void 						FW_PrivDeleteLinkedList(FW_HLinkedList list);

extern FW_HLinkedListIterator 		FW_PrivNewLinkedListIterator(FW_HLinkedList list, 
														FW_PlatformError* error);
extern void 						FW_PrivDeleteLinkedListIterator(FW_HLinkedListIterator iterator);

// For CFM-68K [sfu]

#if defined(FW_ODFLIB_IMPORT)
#pragma import off
#elif defined(FW_ODFLIB)
#pragma export off
#endif

FW_EXTERN_C_END


#endif
